// ************ SIMPLE UTILITIES FOR PROCESSING A POLYGON STORED IN pt P[n]*******
int n=4;                        // current number of points
pt [] P = new pt[1000];            // decalres an array of vertices
int p=0;                         // index to the currently selected vertex being dragged
int next(int j) {  if (j==n-1) {return (0);}  else {return(j+1);}  };  // next point in loop
int prev(int j) {  if (j==0) {return (n-1);}  else {return(j-1);}  };  // previous point in loop                                                     
void declarePoints() {for (int i=0; i<P.length; i++) P[i]=new pt();} // init the vertices to be on a circle
void resetPoints() {for (int i=0; i<n; i++) {P[i]=new pt(width/2,height/7.); P[i].rotateBy(2.*PI*i/n, screenCenter());}; } // init the points to be on a circle
void appendPoint(pt Q)  { P[n++].setTo(Q);  }; // add point at end of list
// ************************************** EDITING *********************************
void dragPoint() { P[p].moveWithMouse(); P[p].clipToWindow(); }   // moves selected point (P[p]) by recent mouse displacement (see TAB polygon)
void dragPoint(vec V) {P[p].translateBy(V);}                      // moves P[p] by vector V
void pickClosestPoint() {pt M = mouse(); p=0; for (int i=1; i<n; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i;} // sets p to the index of point closest to mouse
void pickClosestPoint(pt M) {if(mouseIsInWindow()) { p=0; for (int i=1; i<n; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i; };}
void deletePoint() { for (int i=p; i<n-1; i++) P[i].setTo(P[next(i)]); n--; p=prev(p);}
void translatePoints(vec V) {for (int i=0; i<n; i++) P[i].translateBy(V); };   
void scalePoints(float s) {for (int i=0; i<n; i++) P[i].translateTowards(s,screenCenter());};  
// ************************************** VIEWING *********************************
void showPoints() {for (int i=0; i<n; i++) P[i].show();}
void showPoints(int r) {for (int i=0; i<n; i++) P[i].show(r);}
void drawPointIDs() {for (int i=0; i<n; i++) {vec V=P[i].makeVecToAverage(P[prev(i)],P[next(i)]); V.normalize(); V.scaleBy(-10); V.add(-3,5); P[i].showLabel(str(i),V); };}; 
void drawPolygon() {beginShape();  for (int i=0; i<n; i++) P[i].v(); endShape(CLOSE); }    
void drawPolygon(boolean closed) {beginShape();  for (int i=0; i<n; i++) P[i].v(); if(closed) endShape(CLOSE); else endShape();} // draw (or fill) open (or closed) polygon
void drawEdge(int i) {if((0<=i)&&(i<n)) P[i].to(P[next(i)]);}


